pkgsrc-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[pkgsrc/trunk]: pkgsrc/sysutils/install-sh This package provides a script ``i...



details:   https://anonhg.NetBSD.org/pkgsrc/rev/1159d1e95211
branches:  trunk
changeset: 516206:1159d1e95211
user:      jlam <jlam%pkgsrc.org@localhost>
date:      Mon Jul 17 14:19:01 2006 +0000

description:
This package provides a script ``install-sh'' that is compatible with
the BSD install program.  The script comes from pkgsrc/bootstrap.

diffstat:

 sysutils/install-sh/DESCR               |    2 +
 sysutils/install-sh/Makefile            |   34 +++
 sysutils/install-sh/PLIST               |    2 +
 sysutils/install-sh/files/install-sh.in |  291 ++++++++++++++++++++++++++++++++
 4 files changed, 329 insertions(+), 0 deletions(-)

diffs (truncated from 345 to 300 lines):

diff -r a382ab447cfe -r 1159d1e95211 sysutils/install-sh/DESCR
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/sysutils/install-sh/DESCR Mon Jul 17 14:19:01 2006 +0000
@@ -0,0 +1,2 @@
+This package provides a script ``install-sh'' that is compatible with
+the BSD install program.
diff -r a382ab447cfe -r 1159d1e95211 sysutils/install-sh/Makefile
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/sysutils/install-sh/Makefile      Mon Jul 17 14:19:01 2006 +0000
@@ -0,0 +1,34 @@
+# $NetBSD: Makefile,v 1.1.1.1 2006/07/17 14:19:01 jlam Exp $
+
+DISTNAME=      install-sh-20060714
+CATEGORIES=    sysutils
+MASTER_SITES=  # empty
+DISTFILES=     # empty
+
+MAINTAINER=    pkgsrc-users%NetBSD.org@localhost
+COMMENT=       install script compatible with the BSD install program
+
+USE_TOOLS+=    sed
+NO_CHECKSUM=   yes
+NO_MTREE=      yes
+NO_BUILD=      yes
+
+# Use the install script to perform installation to avoid bootstrapping
+# issues.
+#
+INSTALL_SCRIPT=                \
+       ${SH} ${WRKSRC}/install-sh -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE}
+INSTALL_SCRIPT_DIR=    \
+       ${SH} ${WRKSRC}/install-sh -d -o ${BINOWN} -g ${BINGRP} -m ${PKGDIRMODE}
+
+do-extract:
+       @${CP} -R ${FILESDIR} ${WRKSRC}
+
+do-configure:
+       ${SED}  -e "s|@DEFAULT_INSTALL_MODE@|"${PKGDIRMODE}"|g"         \
+               ${WRKSRC}/install-sh.in > ${WRKSRC}/install-sh
+do-install:
+       ${INSTALL_SCRIPT_DIR} ${PREFIX}/bin
+       ${INSTALL_SCRIPT} ${WRKSRC}/install-sh ${PREFIX}/bin
+
+.include "../../mk/bsd.pkg.mk"
diff -r a382ab447cfe -r 1159d1e95211 sysutils/install-sh/PLIST
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/sysutils/install-sh/PLIST Mon Jul 17 14:19:01 2006 +0000
@@ -0,0 +1,2 @@
+@comment $NetBSD: PLIST,v 1.1.1.1 2006/07/17 14:19:01 jlam Exp $
+bin/install-sh
diff -r a382ab447cfe -r 1159d1e95211 sysutils/install-sh/files/install-sh.in
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/sysutils/install-sh/files/install-sh.in   Mon Jul 17 14:19:01 2006 +0000
@@ -0,0 +1,291 @@
+#!/bin/sh
+#
+# $NetBSD: install-sh.in,v 1.1.1.1 2006/07/17 14:19:01 jlam Exp $
+# This script now also installs multiple files, but might choke on installing
+# multiple files with spaces in the file names.
+#
+# install - install a program, script, or datafile
+# This comes from X11R5 (mit/util/scripts/install.sh).
+#
+# Copyright 1991 by the Massachusetts Institute of Technology
+#
+# Permission to use, copy, modify, distribute, and sell this software and its
+# documentation for any purpose is hereby granted without fee, provided that
+# the above copyright notice appear in all copies and that both that
+# copyright notice and this permission notice appear in supporting
+# documentation, and that the name of M.I.T. not be used in advertising or
+# publicity pertaining to distribution of the software without specific,
+# written prior permission.  M.I.T. makes no representations about the
+# suitability of this software for any purpose.  It is provided "as is"
+# without express or implied warranty.
+#
+# Calling this script install-sh is preferred over install.sh, to prevent
+# `make' implicit rules from creating a file called install from it
+# when there is no Makefile.
+#
+# This script is compatible with the BSD install script, but was written
+# from scratch.
+
+# set DOITPROG to echo to test this script
+
+# Don't use :- since 4.3BSD and earlier shells don't like it.
+doit="${DOITPROG-}"
+
+
+# put in absolute paths if you don't have them in your path; or use env. vars.
+
+mvprog="${MVPROG-mv}"
+cpprog="${CPPROG-cp}"
+chmodprog="${CHMODPROG-chmod}"
+chownprog="${CHOWNPROG-chown}"
+chgrpprog="${CHGRPPROG-chgrp}"
+stripprog="${STRIPPROG-strip}"
+rmprog="${RMPROG-rm}"
+mkdirprog="${MKDIRPROG-mkdir}"
+
+transformbasename=""
+transform_arg=""
+instcmd="$mvprog"
+chmodcmd="$chmodprog @DEFAULT_INSTALL_MODE@"
+chowncmd=""
+chgrpcmd=""
+stripcmd=""
+stripflags=""
+rmcmd="$rmprog -f"
+mvcmd="$mvprog"
+src=""
+msrc=""
+dst=""
+dir_arg=""
+
+while [ x"$1" != x ]; do
+    case $1 in
+       -c) instcmd="$cpprog"
+           shift
+           continue;;
+
+       -d) dir_arg=true
+           shift
+           continue;;
+
+       -m) chmodcmd="$chmodprog $2"
+           shift
+           shift
+           continue;;
+
+       -o) chowncmd="$chownprog $2"
+           shift
+           shift
+           continue;;
+
+       -g) chgrpcmd="$chgrpprog $2"
+           shift
+           shift
+           continue;;
+
+       -s) stripcmd="$stripprog"
+           shift
+           continue;;
+
+       -S) stripcmd="$stripprog"
+           stripflags="-S $2 $stripflags"
+           shift
+           shift
+           continue;;
+
+       -t=*) transformarg=`echo "$1" | sed 's/-t=//'`
+           shift
+           continue;;
+
+       -b=*) transformbasename=`echo "$1" | sed 's/-b=//'`
+           shift
+           continue;;
+
+       *)  if [ x"$src" = x ]
+           then
+               src=$1
+               msrc=$1
+           else
+               # this colon is to work around a 386BSD /bin/sh bug
+               :
+               msrc="$msrc $1"
+               dst=$1
+           fi
+           shift
+           continue;;
+    esac
+done
+
+if [ x"$dir_arg" = x -a x"$msrc" != x"$src $dst" ]
+then
+       if [ ! -d "$dst" ]; then
+               echo "install: destination is not a directory"
+               exit 1
+       fi
+else
+       msrc=$src
+fi
+
+
+if [ x"$src" = x ]
+then
+       echo "install:  no input file specified"
+       exit 1
+else
+       true
+fi
+
+if [ x"$dir_arg" != x ]; then
+       dst=$src
+       src=""
+       
+       if [ -d "$dst" ]; then
+               instcmd=:
+               chmodcmd=""
+       else
+               instcmd=mkdir
+       fi
+else
+
+# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
+# might cause directories to be created, which would be especially bad 
+# if $src (and thus $dsttmp) contains '*'.
+
+       if [ -f "$src" ]
+       then
+               true
+       elif [ -d "$src" ]
+       then
+               echo "install: $src: not a regular file"
+               exit 1
+       elif [ x"$src" = x"/dev/null" ]
+       then
+               instcmd="$cpprog"
+       else
+               echo "install:  $src does not exist"
+               exit 1
+       fi
+       
+       if [ x"$dst" = x ]
+       then
+               echo "install:  no destination specified"
+               exit 1
+       else
+               true
+       fi
+
+# If destination is a directory, append the input filename; if your system
+# does not like double slashes in filenames, you may need to add some logic
+
+       if [ -d "$dst" ]
+       then
+               dst="$dst"/`basename "$src"`
+       else
+               true
+       fi
+fi
+
+## this sed command emulates the dirname command
+dstdir=`echo "$dst" | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
+
+# Make sure that the destination directory exists.
+#  this part is taken from Noah Friedman's mkinstalldirs script
+
+# Skip lots of stat calls in the usual case.
+if [ ! -d "$dstdir" ]; then
+defaultIFS='   
+'
+IFS="${IFS-${defaultIFS}}"
+
+oIFS="${IFS}"
+# Some sh's can't handle IFS=/ for some reason.
+IFS='%'
+set - `echo ${dstdir} | sed -e 's@/@%@g' -e 's@^%@/@'`
+IFS="${oIFS}"
+
+pathcomp=''
+
+while [ $# -ne 0 ] ; do
+       pathcomp="${pathcomp}${1}"
+       shift
+
+       if [ ! -d "${pathcomp}" ] ;
+        then
+               $mkdirprog "${pathcomp}"
+       else
+               true
+       fi
+
+       pathcomp="${pathcomp}/"
+done
+fi
+
+if [ x"$dir_arg" != x ]
+then
+       $doit $instcmd "$dst" &&
+
+       if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dst"; else true ; fi &&
+       if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dst"; else true ; fi &&
+       if [ x"$stripcmd" != x ]; then $doit $stripcmd $stripflags "$dst"; else true ; fi &&
+       if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dst"; else true ; fi
+else
+
+# If we're going to rename the final executable, determine the name now.
+
+       for arg in `echo "$msrc"| sed -e 's/ [^ ]*$//'`; do
+
+               if [ x"$msrc" = x"$src" ]
+               then
+                       file=$dst
+               else
+                       file=$arg
+               fi
+
+               if [ x"$transformarg" = x ] 
+               then
+                       dstfile=`basename "$file"`



Home | Main Index | Thread Index | Old Index